package sk.upjs.projektFyzikov;

import java.util.Scanner;

import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Turtle;

public class Castica extends Turtle {
	/**
	 * Elementarny naboj (v tomto programe je to 10^13 nasobok realneho
	 * elementarneho naboja - naboj protonu)
	 */
	protected static double elementarnyNaboj = 0.000001602;
	/**
	 * Naboj castice(v Coulomboch)
	 */
	protected double naboj = 0.000001602;
	/**
	 * Suradnice castice
	 */
	protected int x;
	protected int y;

	/**
	 * Konstruktor
	 * 
	 * @param x
	 *            -suradnica
	 * @param y
	 *            -suradnica
	 * @param q
	 *            nasobok "elementarneho" naboja
	 */
	public Castica(int x, int y, int q) {
		super(x, y);
		this.x = x;
		this.y = y;
		this.naboj = q * elementarnyNaboj;
		// castice s kladnym nabojom su zobrazene ako cervena bodka
		if (naboj >= 0) {
			ImageShape.Builder imageBuilder = new ImageShape.Builder("images",
					"CervenyDot.png");
			ImageShape cervenyDot = imageBuilder.createShape();
			setShape(cervenyDot);
			// castice s nulovym nabojom su zobrazene ako zelena bodka
			if (naboj == 0) {
				ImageShape.Builder imageBuilder2 = new ImageShape.Builder(
						"images", "ZelenyDot.png");
				ImageShape zelenyDot = imageBuilder2.createShape();
				setShape(zelenyDot);
			}
			// castice so zapornym nabojom su zobrazene ako modra bodka
		} else {
			ImageShape.Builder imageBuilder = new ImageShape.Builder("images",
					"ModryDot.png");
			ImageShape modryDot = imageBuilder.createShape();
			setShape(modryDot);
		}
	}

	public double getNaboj() {
		return naboj;
	}

	public void setNaboj(double naboj) {
		this.naboj = naboj;
	}

	/**
	 * Metoda, ktora povie, ci sa kliklo na casticu
	 * 
	 * @param x
	 *            - suradnica
	 * @param y
	 *            - suradnica
	 * @return true ak sa kliklo na casticu
	 */
	public boolean klikloSaNaMna(int x, int y) {
		return (this.distanceTo(x, y) < 6);
	}

	/**
	 * Nacitanie pozicie a naboja castice z popisu
	 * 
	 * @param popis
	 *            - informacie o jednej castice v tvare x y naboj
	 * @return vrati casticu vytvorenu na zaklade popisu
	 */
	public static Castica zoStringu(String popis) {
		Scanner s = new Scanner(popis);
		s.useDelimiter(" ");
		int x = s.nextInt();
		int y = s.nextInt();
		int q = (int) (Double.parseDouble(s.next()) / elementarnyNaboj);
		s.close();

		return new Castica(x, y, q);
	}

	public static double getElementarnyNaboj() {
		return elementarnyNaboj;
	}

	/**
	 * Vytvori zaznam o castici vo vhodnom formate
	 */
	@Override
	public String toString() {
		return x + " " + y + " " + naboj;
	}
}
