package sk.upjs.projektFyzikov;

import java.awt.event.MouseEvent;
import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Pane;
import sk.upjs.jpaz2.Turtle;

public class DivEButton extends Pane {
	/**
	 * Korytnacka predstavujuca tlacidlo
	 */
	private Turtle button;
	/**
	 * Plocha na ktorej sa bude nachadzat tlacidlo
	 */
	private Plocha plocha;

	/**
	 * Konstruktor
	 * 
	 * @param fyzikalnaPlocha
	 *            - plocha, ktorej funkcionalitu poskytuje toto tlacidlo
	 */
	public DivEButton(Plocha fyzikalnaPlocha) {
		super(100, 48);
		setBorderWidth(0);
		plocha = fyzikalnaPlocha;
		button = new Turtle();
		setTransparentBackground(false);
		ImageShape.Builder imageBuilder = new ImageShape.Builder("images",
				"DivEButton.png");
		// tlacidlo moze byt zapnute alebo vypnute
		imageBuilder.setViewCount(2);
		ImageShape DivEButton = imageBuilder.createShape();
		resize(DivEButton.getWidth(), DivEButton.getHeight());
		button.setShape(DivEButton);
		add(button);
		button.center();
	}

	/**
	 * Metoda, ktora meni vzhlad vypnuteho a zapnuteho tlacidla
	 */
	public void updateView() {
		if (button.getViewIndex() == 1)
			button.setViewIndex(0);
		else
			button.setViewIndex(1);
	}

	/**
	 * Testuje stav tlacidla
	 * 
	 * @return true ak je tlacidlo zapnute
	 */
	public boolean isDivEButtonOn() {
		if (button.getViewIndex() == 1)
			return true;
		return false;
	}

	/**
	 * Realizuje funkcnost tlacidla, ktora spociva vo vykresleni divergencie na
	 * ploche
	 */
	protected void onMouseReleased(int x, int y, MouseEvent detail) {
		if (detail.getButton() == MouseEvent.BUTTON1) {
			updateView();
			if (isDivEButtonOn() == true) {
				plocha.vypocetDivE(plocha.getCastice());
				plocha.vykresliDivE(plocha.getDivergencia());
			} else
				plocha.reset();
		}
	}

	protected boolean onCanClick(int x, int y) {
		return button.containsInShape(x, y);
	}

}
