package sk.upjs.projektFyzikov;

import java.awt.event.MouseEvent;

import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Pane;
import sk.upjs.jpaz2.Turtle;

public class EButton extends Pane {
	/**
	 * Korytnacka predstavujuca tlacidlo
	 */
	private Turtle button;
	/**
	 * Plocha na ktorej sa bude nachadzat tlacidlo
	 */
	private Plocha plocha;
	/**
	 * Ine tlacidlo, ktore ovplyvnuje funkcionalitu tohoto tlacidla
	 */
	private HardcoreButton hardcoreButton;

	/**
	 * Konstruktor
	 * 
	 * @param fyzikalnaPlocha
	 *            - plocha, ktorej funkcionalitu poskytuje toto tlacidlo
	 * @param hardcoreB
	 *            - tlacidlo "Hardcore view"
	 */
	public EButton(Plocha fyzikalnaPlocha, HardcoreButton hardcoreB) {
		super(100, 48);
		setBorderWidth(0);
		plocha = fyzikalnaPlocha;
		button = new Turtle();
		hardcoreButton = hardcoreB;
		setTransparentBackground(false);
		ImageShape.Builder imageBuilder = new ImageShape.Builder("images",
				"EButton.png");
		// tlacidlo moze byt zapnute alebo vypnute
		imageBuilder.setViewCount(2);
		ImageShape EButton = imageBuilder.createShape();
		resize(EButton.getWidth(), EButton.getHeight());
		button.setShape(EButton);
		add(button);
		button.center();
	}

	/**
	 * Zabezpecuje funkcionalitu tlacidla, ktore vykresluje vektory E
	 */
	protected void onMouseReleased(int x, int y, MouseEvent detail) {
		if (detail.getButton() == MouseEvent.BUTTON1) {
			updateView();
			if (isEButtonOn() == true) {
				if (hardcoreButton.isHardcoreViewOn() == true) {
					plocha.vykresliE(plocha.vypocetHardcoreE(plocha
							.getCastice()));

				} else
					plocha.vykresliE(plocha.vypocetNormalE(plocha.getCastice()));
			} else
				plocha.reset();

		}

	}

	/**
	 * Metoda, ktora meni vzhlad vypnuteho a zapnuteho tlacidla
	 */
	public void updateView() {
		if (button.getViewIndex() == 1)
			button.setViewIndex(0);
		else
			button.setViewIndex(1);
	}

	/**
	 * Testuje stav tlacidla
	 * 
	 * @return true ak je tlacidlo zapnute
	 */
	public boolean isEButtonOn() {
		if (button.getViewIndex() == 1)
			return true;
		return false;
	}

	protected boolean onCanClick(int x, int y) {
		return button.containsInShape(x, y);
	}

}
