package sk.upjs.projektFyzikov;

import java.awt.Font;

import sk.upjs.jpaz2.Pane;
import sk.upjs.jpaz2.Turtle;

public class EPanel extends Pane {
	/**
	 * Korytnacka, ktora bude zapisovat hodnoty do panelu
	 */
	private Turtle pisac;
	/**
	 * |E|
	 */
	private double velkost;
	/**
	 * Plocha na ktorej sa bude nachadzat panel
	 */
	private Plocha plocha;
	/**
	 * Suradnice vypisujucej korytnacky
	 */
	private int x;
	private int y;

	/**
	 * Konstruktor
	 * 
	 * @param fyzikalnaPlocha
	 *            - plocha poskytujuca udaje na vypisanie
	 */
	public EPanel(Plocha fyzikalnaPlocha) {
		super(200, 50);
		setTransparentBackground(false);
		plocha = fyzikalnaPlocha;
		pisac = new Turtle();
		add(pisac);
		pisac.setTransparency(1);
		x = 5;
		y = this.getHeight() / 2 + 5;
		pisac.setPosition(x, y);
		pisac.turn(90);
		pisac.setFont(new Font("Lucida Sans", Font.BOLD, 16));
	}

	/**
	 * Aktualizuje vypisanu hodnotu
	 */
	public void refresh() {
		clear();
		pisac.setPosition(x, y);
		// zaokruhlenie na 5 desatinnych miest
		velkost = (double) Math.round(plocha.getKrok() * 100000) / 100000;
		// V/m = volt / meter
		pisac.print("E = " + velkost + " V/m");
	}

}
