package sk.upjs.projektFyzikov;

import java.awt.event.MouseEvent;

import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Pane;
import sk.upjs.jpaz2.Turtle;

public class HardcoreButton extends Pane {
	/**
	 * Korytnacka predstavujuca tlacidlo
	 */
	private Turtle button;

	/**
	 * Konstruktor
	 */
	public HardcoreButton() {
		super(100, 48);
		setBorderWidth(0);
		button = new Turtle();
		setTransparentBackground(false);
		ImageShape.Builder imageBuilder = new ImageShape.Builder("images",
				"HardcoreButton.png");
		// tlacidlo moze byt zapnute alebo vypnute
		imageBuilder.setViewCount(2);
		ImageShape HardcoreButton = imageBuilder.createShape();
		resize(HardcoreButton.getWidth(), HardcoreButton.getHeight());
		button.setShape(HardcoreButton);
		add(button);
		button.center();
	}

	/**
	 * Metoda, ktora meni vzhlad vypnuteho a zapnuteho tlacidla
	 */
	public void updateView() {
		if (button.getViewIndex() == 1)
			button.setViewIndex(0);
		else
			button.setViewIndex(1);
	}

	/**
	 * Testuje stav tlacidla
	 * 
	 * @return true ak je tlacidlo zapnute
	 */
	public boolean isHardcoreViewOn() {
		if (button.getViewIndex() == 1)
			return true;
		return false;
	}

	protected void onMouseReleased(int x, int y, MouseEvent detail) {
		updateView();
	}

	protected boolean onCanClick(int x, int y) {
		return button.containsInShape(x, y);
	}
}
