package sk.upjs.projektFyzikov;

import java.awt.event.MouseEvent;

import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Pane;
import sk.upjs.jpaz2.Turtle;

public class IntroScreen extends Pane {
	/**
	 * Vytvori uvodnu obrazovku o velkosti 800x600 s pozadim
	 */
	public IntroScreen() {
		super(800, 600);
		setBorderWidth(0);
		Turtle introImage = new Turtle();
		introImage.setShape(new ImageShape("images", "Intro.png"));
		add(introImage);
		introImage.center();
		introImage.stamp();
		remove(introImage);
	}

	/**
	 * 
	 * @param x
	 *            suradnica kliknutia
	 * @param y
	 *            suradnica kliknutia
	 * @return true ak sa kurzor nachadza nad tlacidlom start
	 */
	private boolean jeNadStart(int x, int y) {
		return (0 <= x) && (x <= 184) && (0 <= y) && (y <= 95);
	}

	/**
	 * 
	 * @param x
	 *            suradnica kliknutia
	 * @param y
	 *            suradnica kliknutia
	 * @return true ak sa kurzor nachadza nad tlacidlom exit
	 */
	private boolean jeNadExit(int x, int y) {
		return (getWidth() - 184 <= x) && (x <= getWidth())
				&& (getHeight() - 95 <= y) && (y <= getHeight());
	}

	/**
	 * Kliknutie na tlacidlo "Start" zapne aplikaciu, kliknutie na "Exit" ju
	 * vypne
	 */
	@Override
	protected void onMouseClicked(int x, int y, MouseEvent detail) {
		if (detail.getButton() == MouseEvent.BUTTON1) {
			if (jeNadStart(x, y)) {
				Spustac.spustiAplikaciu();
			}
			if (jeNadExit(x, y)) {
				System.exit(0);
			}
		}
	}

	/**
	 * Zobrazenie symbolu ruky nad tlacidlom
	 */
	protected boolean onCanClick(int x, int y) {
		return super.onCanClick(x, y) || jeNadStart(x, y) || jeNadExit(x, y);
	}

}
