package sk.upjs.projektFyzikov;

import java.awt.event.MouseEvent;

import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Pane;
import sk.upjs.jpaz2.Turtle;

public class PridajNaboj extends Pane {

	/**
	 * Korytnacka predstavujuca tlacidlo
	 */
	private Turtle button;
	/**
	 * Plocha na ktorej sa bude nachadzat tlacidlo
	 */
	private Plocha plocha;
	/**
	 * True ak je hodnota naboja kladne cislo
	 */
	private boolean jeKladny;

	/**
	 * Konstruktor pre tlacidlo na pridanie naboja a odobratie naboja
	 * 
	 * @param fyzikalnaPlocha
	 *            - plocha, ktorej funkcionalitu poskytuje toto tlacidlo
	 * @param jeKladny
	 *            - informacia o znamienku naboja
	 */
	public PridajNaboj(Plocha fyzikalnaPlocha, boolean jeKladny) {
		super(100, 48);
		this.jeKladny = jeKladny;
		setBorderWidth(0);
		plocha = fyzikalnaPlocha;
		button = new Turtle();
		setTransparentBackground(false);
		// pre pridavanie naboja sa vytvori tlacidlo so znakom "+"
		if (jeKladny == true) {
			ImageShape.Builder imageBuilder = new ImageShape.Builder("images",
					"PlusButton.png");
			ImageShape Button = imageBuilder.createShape();
			button.setShape(Button);
			add(button);
			button.center();

			// pre odoberanie naboja sa vytvori tlacidlo so znakom "-"
		} else {
			ImageShape.Builder imageBuilder = new ImageShape.Builder("images",
					"MinusButton.png");
			ImageShape Button = imageBuilder.createShape();
			button.setShape(Button);
			add(button);
			button.center();
		}
	}

	/**
	 * Kliknutie lavym tlacidlo prida resp. odoberie jeden nasobok elementarneho
	 * naboja, prave tlacidlo prida / odoberie 10
	 */
	protected void onMouseReleased(int x, int y, MouseEvent detail) {
		if (detail.getButton() == MouseEvent.BUTTON1) {
			if (jeKladny == true) {
				plocha.setNaboj(plocha.getNaboj() + 1);
			} else {
				plocha.setNaboj(plocha.getNaboj() - 1);
			}
		}
		if (detail.getButton() == MouseEvent.BUTTON3) {
			if (jeKladny == true) {
				plocha.setNaboj(plocha.getNaboj() + 10);
			} else {
				plocha.setNaboj(plocha.getNaboj() - 10);
			}
		}

	}

	protected boolean onCanClick(int x, int y) {
		return button.containsInShape(x, y);
	}
}
