package sk.upjs.projektFyzikov;

import java.awt.event.MouseEvent;

import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Pane;
import sk.upjs.jpaz2.Turtle;

public class ResetButton extends Pane {
	/**
	 * Korytnacka predstavujuca tlacidlo
	 */
	private Turtle button;
	/**
	 * Plocha na ktorej sa bude nachadzat tlacidlo
	 */
	private Plocha plocha;

	/**
	 * Konstruktor
	 * 
	 * @param fyzikalnaPlocha
	 */
	public ResetButton(Plocha fyzikalnaPlocha) {
		super(100, 48);
		setBorderWidth(0);
		plocha = fyzikalnaPlocha;
		button = new Turtle();
		setTransparentBackground(false);
		ImageShape.Builder imageBuilder = new ImageShape.Builder("images",
				"ResetButton.png");
		ImageShape ResetButton = imageBuilder.createShape();
		button.setShape(ResetButton);
		add(button);
		button.center();
	}

	/**
	 * Kliknutie na tlacidlo vycisti plochu, vyprazdni list castic a vsetky
	 * zobrazene hodnoty nastavi na nulu
	 */
	protected void onMouseReleased(int x, int y, MouseEvent detail) {
		if (detail.getButton() == MouseEvent.BUTTON1)
			plocha.resetAll();
	}

	protected boolean onCanClick(int x, int y) {
		return button.containsInShape(x, y);
	}
}
