package sk.upjs.projektFyzikov;

import java.awt.event.MouseEvent;

import javax.swing.JFileChooser;

import sk.upjs.jpaz2.ImageShape;
import sk.upjs.jpaz2.Pane;
import sk.upjs.jpaz2.Turtle;

public class SavePositionButton extends Pane {
	/**
	 * Korytnacka predstavujuca tlacidlo
	 */
	private Turtle button;
	/**
	 * Plocha na ktorej sa bude nachadzat tlacidlo
	 */
	private Plocha plocha;

	/**
	 * Konstruktor
	 * 
	 * @param fyzikalnaPlocha
	 *            - plocha, ktorej funkcionalitu poskytuje toto tlacidlo
	 */
	public SavePositionButton(Plocha fyzikalnaPlocha) {
		super(100, 48);
		setBorderWidth(0);
		plocha = fyzikalnaPlocha;
		button = new Turtle();
		setTransparentBackground(false);
		ImageShape.Builder imageBuilder = new ImageShape.Builder("images",
				"UlozButton.png");
		ImageShape UlozButton = imageBuilder.createShape();
		button.setShape(UlozButton);
		add(button);
		button.center();
	}

	/**
	 * Po kliknuti na tlacidlo sa zobrazi dialogove okno, ktore umoznuje vybrat
	 * subor, do ktoreho sa ulozia pozicie castic a nasledne sa don ulozia
	 * 
	 */
	protected void onMouseReleased(int x, int y, MouseEvent detail) {
		JFileChooser fc = new JFileChooser();
		int volba = fc.showSaveDialog(null);
		if (volba == JFileChooser.APPROVE_OPTION) {
			plocha.uloz(fc.getSelectedFile());
			System.out.println("Zvolen sbor: "
					+ fc.getSelectedFile().getName());
		} else {
			System.out.println("iaden sbor nebol zvolen");
		}

	}

	protected boolean onCanClick(int x, int y) {
		return button.containsInShape(x, y);
	}
}
